import greenfoot.*;
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends SmoothMover
{
    int delay = 5;
    int delay2 = 2;
    boolean loop = true;
    boolean up = true;
    int x;
    int y;
    int realY;
    
    public Player(int X, int Y)
    {
        x=X;
        y=Y;
        realY=Y;
    }
    
    public void act() 
    {
        tractorBeam();
        animate();
        move();
    }
    
    public boolean isKeyDown()
    {
        String keys = "abcdefghijklmnopqrstuvwxyz1234567890!@#$%^&*()_-+={[}]|\\<,>.?/`~";  
        String[] specialKeys = { "enter", "escape", "space", "backspace", "tab", "shift", "control",  "up", "down", "left", "right", "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10", "F11", "F12" };  
        int i = 0;  
        for (i=0; i<keys.length(); i++) if (Greenfoot.isKeyDown(keys.substring(i, i+1))) break;  
        boolean keyFoundDown =  i < keys.length();  
        if (!keyFoundDown)  
        {  
            for (i=0; i<specialKeys.length; i++) if (Greenfoot.isKeyDown(specialKeys[i])) break;  
            keyFoundDown = i < specialKeys.length;  
        }  
        if (keyFoundDown)
            return true;
        else
            return false;
    }
    
    public int getKeys()
    {
        String keys = "abcdefghijklmnopqrstuvwxyz1234567890!@#$%^&*()_-+={[}]|\\<,>.?/`~";  
        String[] specialKeys = { "enter", "escape", "space", "backspace", "tab", "shift", "control",  "up", "down", "left", "right", "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10", "F11", "F12" };  
        int i = 0;  
        for (int a=0; a<keys.length(); a++) 
            if (Greenfoot.isKeyDown(keys.substring(a, a+1))) 
                i++;
        for (int b=0; b<specialKeys.length; b++)
            if (Greenfoot.isKeyDown(specialKeys[b]))
                i++;  
        return i;
    }
    
    public void tractorBeam()
    {
        if(Greenfoot.isKeyDown("space")){
            if(delay==5&&loop==true){
                setImage("CharTractorBeam1.png");
                delay = 0;
                loop = false;
            }else if(delay==5){
                setImage("CharTractorBeam2.png");
                delay = 0;
                loop = true;
            }else{
                delay++;
            }
            Rock rock = (Rock)getOneIntersectingObject(Rock.class);
            if(rock!=null){
                int originalR = rock.getRotation();
                rock.setRotation(getRotation()+90);
                double radians = Math.toRadians(rock.getRotation());
                double dx = Math.cos(radians) * (25 + rock.getImage().getHeight()/2);
                double dy = Math.sin(radians) * (25 + rock.getImage().getHeight()/2);
                rock.x = x - (int)dx;
                rock.y = realY - (int)dy;
                rock.scroll(rock.x, rock.y);
                rock.setRotation(originalR);
            }
        }else{
            setImage("Char.png");
            delay = 5;
        }
    }
    
    public void animate()
    {
        Worldy world = (Worldy)getWorld();
        Flame flame;
        Flame flame2;
        if(Greenfoot.isKeyDown("d"))
            flame = new Flame(20, getRotation()+90, 5, 10);
        else
            flame = new Flame(15, getRotation()+90, 3, 10);
        if(Greenfoot.isKeyDown("a"))
            flame2 = new Flame(20, getRotation()+90, 5, 10);
        else
            flame2 = new Flame(15, getRotation()+90, 3, 10);
        world.addObject(flame, getX(), getY());
        world.addObject(flame2, getX(), getY());
        flame.turn(90);
        flame2.turn(-90);
        flame.move(16);
        flame2.move(16);
        flame.turn(-90);
        flame2.turn(90);
        flame.move(13);
        flame2.move(13);
        flame.x = x - (flame.getX()-getX());
        flame2.x = x - (flame2.getX()-getX());
        flame.y = realY - (flame.getY()-getY());
        flame2.y = realY - (flame2.getY()-getY());
        flame.scroll(flame.x, flame.y);
        flame2.scroll(flame2.x, flame2.y);
        if(getY()>world.getHeight()/2-5&&up==true&&(!isKeyDown()||(Greenfoot.isKeyDown("space")&&getKeys()==1))){
            if(delay2>=2){
                setLocation(getX(), getY()-1);
                realY+=1;
                delay2 = 0;
            }else
                delay2++;
        }else{
            up = false;
        }
        if(getY()<world.getHeight()/2+5&&up==false&&(!isKeyDown()||(Greenfoot.isKeyDown("space")&&getKeys()==1))){
            if(delay2>=2){
                setLocation(getX(), getY()+1);
                realY-=1;
                delay2 = 0;
            }else
                delay2++;
        }else{
            up = true;
        }
        if(!Greenfoot.isKeyDown("a")&&Greenfoot.isKeyDown("d")){
            if(getRotation()!=44)
                turn(2);
        }else if(!Greenfoot.isKeyDown("d")&&Greenfoot.isKeyDown("a")){
            if(getRotation()!=316)
                turn(-2);
        }else{
            if(getRotation()>315&&getRotation()!=0){
                turn(2);
            }else if(getRotation()>0){
                turn(-2);
            }
        }
    }
    
    public boolean canSee(int dx, int dy, Class clss)
    {
        Actor actor = getOneObjectAtOffset(dx, dy, clss);
        return actor != null;
    }
    
    public boolean canSee(int x1, int y1, int x2, int y2, Class clss)
    {
        boolean can = false;
        for(int x = x1; x < x2; x++){
            for(int y = y1; y < y2; y++){
                Actor actor = getOneObjectAtOffset(x, y, clss);
                can = actor != null;
            }
        }
        return can;
    }
    
    public void move()
    {
        Worldy world = (Worldy)getWorld();
        while(world.back.getColorAt(getX()+15-x,getY()-40-y).getBlue()<100){
            y--;
            realY--;
        }
        while(world.back.getColorAt(getX()-15-x,getY()-40-y).getBlue()<100){
            y--;
            realY--;
        }
        while(world.back.getColorAt(getX()-x,getY()+25-y).getBlue()<100){
            y++;
            realY++;
        }
        Rock rock = (Rock)getOneIntersectingObject(Rock.class);
        ElectronicDoor eDR = (ElectronicDoor)getOneObjectAtOffset(getImage().getWidth()/2, 0, ElectronicDoor.class);
        ElectronicDoor eDL = (ElectronicDoor)getOneObjectAtOffset(-getImage().getWidth()/2, 0, ElectronicDoor.class);
        if(!Greenfoot.isKeyDown("a")&&Greenfoot.isKeyDown("d")&&x>-world.back.getWidth()+world.getWidth()&&world.back.getColorAt(getX()+30-x,getY()-y).getBlue()>100&&(!Greenfoot.isKeyDown("space")||(Greenfoot.isKeyDown("space")&&rock==null)||(Greenfoot.isKeyDown("space")&&rock!=null&&!canSee(rock.getImage().getWidth()/2, 25+rock.getImage().getHeight()/2, Rock.class)))&&!canSee(getImage().getWidth()/2, 0, Rock.class)&&(eDR==null||(eDR!=null&&eDR.open==true))){
            x-=3;
        }else if(!Greenfoot.isKeyDown("d")&&Greenfoot.isKeyDown("a")&&x<0&&world.back.getColorAt(getX()-30-x,getY()-y).getBlue()>100&&(!Greenfoot.isKeyDown("space")||(Greenfoot.isKeyDown("space")&&rock==null)||(Greenfoot.isKeyDown("space")&&rock!=null&&!canSee(-rock.getImage().getWidth()/2, 25+rock.getImage().getHeight()/2, Rock.class)))&&!canSee(-getImage().getWidth()/2, 0, Rock.class)&&(eDL==null||(eDL!=null&&eDL.open==true))){
            x+=3;
        }else if(Greenfoot.isKeyDown("a")&&Greenfoot.isKeyDown("d")&&y<-6)
        {
            y+=4;
            realY+=4;
        }
        if(Greenfoot.isKeyDown("s")&&y>-world.back.getHeight()+world.getHeight()+5&&(!Greenfoot.isKeyDown("space")||(Greenfoot.isKeyDown("space")&&rock==null)||(Greenfoot.isKeyDown("space")&&rock!=null&&world.back.getColorAt(getX()-x,getY()+25+rock.getImage().getHeight()-y).getBlue()>100))&&(!Greenfoot.isKeyDown("space")||(Greenfoot.isKeyDown("space")&&rock==null)||(Greenfoot.isKeyDown("space")&&rock!=null&&!canSee(0, 25+rock.getImage().getHeight(), Rock.class)))&&(!canSee(0, 25, Rock.class)||Greenfoot.isKeyDown("space"))){
            y-=3;
            realY-=3;
        }else if(Greenfoot.isKeyDown("w")&&y<-5){
            y+=3;
            realY+=3;
        }
        if(x<-world.back.getWidth()+world.getWidth()+5){
                world.levelUpdate(world.level+1);
        }else if(x>-5){
                if(world.level>1){
                    world.levelUpdate(world.level-1);
                }
        }
    }
}
