import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Worldy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worldy extends World
{
    GreenfootImage colorBack;
    Player player;
    int level = 0;
    GreenfootImage back;
    int x=-40;
    int y=-850;
    /**
     * Constructor for objects of class world.
     * 
     */
    public Worldy()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1, false);
        levelUpdate(level);
        setPaintOrder(Avatar.class, Player.class, Flame.class);
    }
    
    public void levelUpdate(int l)
    {
        if(l<=3){
            removeObjects(getObjects(null));
            if(l==-1){
                colorBack = new GreenfootImage("MenuBack.png");
                setBackground(colorBack);
                addObject(new Avatar(),400,200);
                addObject(new MenuButton(),400, 275);
                addObject(new Instructions(),200,250);
            }else if(l==0){
                colorBack = new GreenfootImage("MenuBack.png");
                setBackground(colorBack);
                addObject(new Avatar(),400,200);
                addObject(new StartButton(),173,150);
                addObject(new InstructButton(),200,250);
                addObject(new LOGO(), 300, 65);
            }else if(l==1){
                colorBack = new GreenfootImage("CPart1.png");
                back = new GreenfootImage("B&WPart1.png");
                if(l>=level)
                    player = new Player(-40, -850);
                else
                    player = new Player(-763, -850);
                addObject(player,300,200);
                getBackground().drawImage(colorBack,player.x,player.y);
            }else if(l==2){
                colorBack = new GreenfootImage("CPart2.png");
                back = new GreenfootImage("B&WPart2.png");
                if(l>=level)
                    player = new Player(-40, -350);
                else
                    player = new Player(-850, -350);
                addObject(player,300,200);
                Rock rock = new Rock(40, -500, -350);
                addObject(rock, 0, 0);
                rock.scroll(rock.x, rock.y);
                Rock rock2 = new Rock(30, -540, -350);
                addObject(rock2, 0, 0);
                rock2.scroll(rock2.x, rock2.y);
                Rock rock3 = new Rock(35, -540, -285);
                addObject(rock3, 0, 0);
                rock3.scroll(rock3.x, rock3.y);
                Rock rock4 = new Rock(45, -500, -240);
                addObject(rock4, 0, 0);
                rock4.scroll(rock4.x, rock4.y);
                getBackground().drawImage(colorBack,player.x,player.y);
            }else if(l==3){
                colorBack = new GreenfootImage("CPart3.png");
                back = new GreenfootImage("B&WPart3.png");
                if(l>=level)
                    player = new Player(-40, -150);
                else
                    player = new Player(-850, -570);
                addObject(player,300,200);
                Rock rock = new Rock(60, -390, -396);
                addObject(rock, 0, 0);
                rock.scroll(rock.x, rock.y);
                Rock rock2 = new Rock(60, -300, -407);
                addObject(rock2, 0, 0);
                rock2.scroll(rock2.x, rock2.y);
                Rock rock3 = new Rock(40, -340, -380);
                addObject(rock3, 0, 0);
                rock3.scroll(rock3.x, rock3.y);
                TractorButton tB = new TractorButton(-600, -649);
                addObject(tB, 0, 0);
                tB.scroll(tB.x, tB.y);
                TractorButton tB2 = new TractorButton(-792, -619);
                addObject(tB2, 0, 0);
                tB2.scroll(tB2.x, tB2.y);
                ElectronicDoor eD = new ElectronicDoor(225, -689, -540);
                addObject(eD, 0, 0);
                eD.scroll(eD.x, eD.y);
                getBackground().drawImage(colorBack,player.x,player.y);
            }
            if(l>level){
                while(l>level){
                    level++;
                }
            }else if(l<level){
                while(l<level){
                    level--;
                }
            }
        }
    }
    
    public void act()
    {
        if(player != null){
            getBackground().drawImage(colorBack,player.x,player.y);
            x = player.x;
            y = player.y;
        }
    }
}
